import play.api._
import play.api.mvc._

import events._
import sourcing._
import models._
import models.sourcing._

import play.api.libs._
import play.api.libs.json._
import play.api.libs.json.Json._

import java.util.UUID.randomUUID
import scala.util.Random.nextInt

import scalaz._
import Scalaz._

import scalax.io._
import scalax.file._

object Global extends GlobalSettings {

	val testUsers = Seq(
		User("noah", "Noah", "Petrella", 1),
		User("sandrine", "Sandrine", "Gomez Steurs", 30),
		User("noootsab", "Andy", "Petrella", 30)
	)  ++ (1 to 8) map {i => User("guy"+i, "John", "Smith", -1)}

	override def onStart(app: Application) {
		//todo parse the events-$n-.log files 
		//       then apply them using ModelSourcing.transaction
		// JSON lines ... it would be more simple...


		import User.structure._
		ModelSourcing.inTransaction {
			for {

				noah 		<- toSourcingTuple(Created(testUsers(0)).sourcing);
				noah2		<- esAge.set(noah, 2);
				sandrine 	<- Created(testUsers(1)).sourcing;
				noootsab 	<- Created(testUsers(2)).sourcing;
				guy1 		<- Created(testUsers(3)).sourcing;
				guy2 		<- Created(testUsers(4)).sourcing;
				guy3 		<- Created(testUsers(5)).sourcing;
				guy4 		<- Created(testUsers(6)).sourcing;
				guy5 		<- Created(testUsers(7)).sourcing;
				guy6 		<- Created(testUsers(8)).sourcing;
				guy7 		<- Created(testUsers(9)).sourcing;
				guy8 		<- Created(testUsers(10))sourcing;
				link1 		<- esAddFriend(noah2)(noootsab)._1;
				link2 		<- esAddFriend(sandrine)(link1)._1;

				post1		<- Created(Post(noah.id, None, "mkdnadvpae ge gzepasasc"))
				post2		<- Created(Post(sandrine.id, None, "My kid has written his first post!"))
				post3		<- Created(Post(noootsab.id, Some(post2.model.id), "Great !!"))
				post4		<- Created(Post(noootsab.id, Some(post1.model.id), "Well done, son!"))
			} yield post4
      	}

	}

	override def onStop(app: Application) {
		implicit val codec = scalax.io.Codec.UTF8

		if (false) { //disabled since no read is done
		val eventsLog = Path(eventLogFile(app, 0))
			eventsLog.append("# created at " + new java.util.Date())
			ModelSourcing.objects().events.reverse.map {e => eventsLog.append(e.toString)} //todo store in JSON (or alike) for simplicity
			eventsLog.append("# written at " + new java.util.Date())
			println("Events saved")
		}
	}

	def eventLogFile(app: Application, n:Int):java.io.File = {
		val f = app.getFile("/conf/events-"+n+".log")
		if (!f.exists) {
			f
		} else {
			eventLogFile(app, n+1)
		}
	}
  
}