package controllers

import play.api._
import play.api.mvc._
import play.api.data.Forms._
import play.api.data._
/** Uncomment the following lines as needed **/
/**
import play.api.Play.current
import play.api.libs._
import play.api.libs.iteratee._
import play.api.libs.concurrent._
import java.util.concurrent._
import scala.concurrent.stm._
import akka.util.duration._
import play.api.cache._
**/
import events._
import sourcing._
import models._
import models.sourcing._

import play.api.libs.json._
import play.api.libs.json.Json._

import java.util.UUID.randomUUID
import scala.util.Random.nextInt

import scalaz._
import Scalaz._

object Posts extends Controller {

	val newPostForm = Form( 
		mapping(
			"by" -> nonEmptyText, 
			"replyTo" -> optional(text), 
			"content" -> nonEmptyText, 
			"id" -> text
		)(Post.apply)(Post.unapply)
	)

	def all = Action { implicit request =>
		Ok(toJson(ModelSourcing.objects().current.values.filter(_.isInstanceOf[Post]).toSeq.asInstanceOf[Seq[Post]]))
	}

	def addPost = Action { implicit request =>
		newPostForm.bindFromRequest.fold (
		    formWithErrors => BadRequest( "missing parameter!" ),
		    { post => {
		    		request.session.get("userId").map { _ =>
				        ModelSourcing.transaction(events.Created(post))
				        Ok(post.id)
		    		}.getOrElse {
		    			Unauthorized("You're dull or what?")
		    		} 
		        }
		    }
		)		
	}

	def theirPosts(id:String) = Action { implicit request =>
		ModelSourcing.get(id) cata (
			{case user:User =>
				Ok(views.html.theirposts(User.structure.friends(user).map {friend => 
					(
						friend, 
						ModelSourcing.objects().current.values.
							filter(p => p.isInstanceOf[Post] && p.asInstanceOf[Post].by == friend.id).
							toSeq.asInstanceOf[Seq[Post]]
					)
				}))
			},
			BadRequest("bad id")
		)
	}

	def by(id:String) = Action { implicit request =>
		request.session.get("userId").map { ui =>
			if (ui == id || ModelSourcing.get(ui).map {us => us.asInstanceOf[User].friends.exists(_==id)}.getOrElse(false)) {
				Ok(
					views.html.myposts(ModelSourcing.objects().current.values.
						filter(p => p.isInstanceOf[Post] && p.asInstanceOf[Post].by == id)
						.toSeq.asInstanceOf[Seq[Post]],
						newPostForm
					)
				)
			} else {
				Unauthorized("cannot see his posts")
			}
		}.getOrElse {
			Unauthorized("not connected")
		} 
	}


}