package events

import models._

trait ModelEvent[T <: Model] extends Event {

	def apply[A](a:A) = applyModel(a.asInstanceOf[T]).asInstanceOf[A]

	def applyModel(model:T):T

}

case class Init[T <: Model](model:T) extends ModelEvent[T] {
	def applyModel(t:T):T = model
	def sourcing = (this, model)
}

case class Created[T <: Model](model:T) extends ModelEvent[T] {
	def applyModel(t:T):T = model
	def sourcing = (this, model)
}