package events

import models._

case class SetBy(id:String, newValue:String) extends ModelEvent[Post] {
	def applyModel(post:Post) = Post.structure.by.set(post, newValue)
}

case class SetReplyTo(id:String, newValue:Option[String]) extends ModelEvent[Post] {
	def applyModel(post:Post) = Post.structure.replyTo.set(post, newValue)
}

case class SetContent(id:String, newValue:String) extends ModelEvent[Post] {
	def applyModel(post:Post) = Post.structure.content.set(post, newValue)
}