package events

import models._

case class SetUserName(id:String, newValue:String) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure.userName.set(user, newValue)
}

case class SetFirstName(id:String, newValue:String) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure.firstName.set(user, newValue)
}

case class SetLastName(id:String, newValue:String) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure.lastName.set(user, newValue)
}

case class SetAge(id:String, newValue:Int) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure.age.set(user, newValue)
}

case class SetFriends(id:String, friends:Seq[User]) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure.friends.set(user, friends)
}

case class AddFriend(id:String, newFriend:String) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure._addFriend(user, newFriend)
}

case class RemoveFriend(id:String, friend:String) extends ModelEvent[User] {
	def applyModel(user:User) = User.structure._removeFriend(user, friend)
}