package models

import scalaz._
import Scalaz._

import events._

object sourcing {
	implicit def toSourcingElement[A](a:A)(implicit init:A=>Event):Writer[Seq[Event], A] = writer(Seq(init(a)), a)
	implicit def toSourcingTuple[A](e:(Event, A)):Writer[Seq[Event], A] = writer(Seq(e._1), e._2)
	implicit def toSourcingTupleSeq[A](e:(Seq[Event], A)):Writer[Seq[Event], A] = writer(e._1, e._2)

	def eventSoucedFieldLens[A, B, C](lens:Lens[A,B])(key:A=>C, eventing:(C, B)=>Event):Lens[Writer[Seq[Event], A], B] = 
		Lens(
			w => lens.get(w.value._2), 
			(w, s) => stateWriter(key, eventing((_:C),(_:B)))(s)(w)._1
		)

	def stateWriter[A, B, C](key:A=>C, eventing:(C, B)=>Event): B => State[Writer[Seq[Event], A], A] = 
		newB =>
			state { wrtr => {
					val (events, a) = wrtr.value
					
					val event = eventing(key(a), newB)
					val newA = event.apply(a) 
					
					val w = writer(event +: events, newA)
					
					(w, newA)
				}
			}
}