package sourcing 

import models._
import events._

trait PostSourcing extends Sourcing { this:ModelSourcing =>
	
	def applyPostEvent:PartialFunction[Event, ModelSourcing] = {
		case e@Init(m) => this
		case e@Created(m) => updateModel(e)(m)
		case e@SetBy(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@SetReplyTo(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@SetContent(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
	}

	override def _apply:PartialFunction[Event, ModelSourcing] = applyPostEvent orElse super._apply
}