package sourcing 

import models._
import events._

trait UserSourcing extends Sourcing { this:ModelSourcing =>
	
	def applyUserEvent:PartialFunction[Event, ModelSourcing] = {
		case e@Init(m) => this
		case e@Created(m) => updateModel(e)(m)
		case e@SetUserName(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@SetFirstName(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@SetLastName(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@SetAge(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@AddFriend(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
		case e@RemoveFriend(id, _) => applyEvent(id, e) map updateModel(e) getOrElse this
	}

	override def _apply:PartialFunction[Event, ModelSourcing] = applyUserEvent orElse super._apply
}